package fr.inra.pappso.xtandempipeline.class_msms.IdentificationDataFile;

import java.io.File;

import javax.xml.stream.XMLStreamWriter;

import fr.inra.pappso.xtandempipeline.class_msms.Identification;
import fr.inra.pappso.xtandempipeline.class_msms.Peptide;

public abstract class IdentificationDataFile implements
		IdentificationDataSource {

	protected File file = null;

	@Override
	public String getName() {
		return this.file.getName();
	}

	public String getAbsolutePath() {
		return this.file.getAbsolutePath();
	}

	public File getFile() {
		return this.file;
	}

	@Override
	public boolean exists() {
		return this.file.exists();
	}

	@Override
	public int compareTo(IdentificationDataSource toCompare) {
		IdentificationDataFile dataFile = (IdentificationDataFile) toCompare;
		return this.file.compareTo(dataFile.file);
	}

	@Override
	public boolean equals(IdentificationDataSource toCompare) {
		IdentificationDataFile dataFile = (IdentificationDataFile) toCompare;
		return this.file.equals(dataFile.file);
	}

	@Override
	public int hashCode() {
		return file.hashCode();
	}

	@Override
	abstract public Identification loadIdentification(
			Identification previousIdentification) 
					throws Exception;

	@Override
	abstract public Identification loadPhosphoIdentification(
			Identification previousIdentification) 
					throws Exception;

	@Override
	abstract public boolean loadMSMSSpectra(Peptide pep) throws Exception;

	@Override
	abstract public void writeXpipPeptideSourceAttribute(XMLStreamWriter writer)
			throws Exception;

}
