package fr.inra.pappso.xtandempipeline.filter_print;

import java.util.ArrayList;

import fr.inra.pappso.libodsstream.OdsDocWriter;
import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.grouping.Group;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetProt;
import fr.inra.pappso.xtandempipeline.grouping.SubGroup;

public class print_ods_protein_to_combined extends printOdsBase {

	public print_ods_protein_to_combined(OdsDocWriter odsTable) {
		super(odsTable);
		// super(out);
		logger.info("Print Protein liste file in Combined mode");
	}

	public void print_header() throws Exception {
		logger.debug("print_header Protein liste file in Combined mode");

		odsTable.writeLine();
		// out.write(samp.getSampleName() + "\n");
		ArrayList<String> headStrList = new ArrayList<String>();
		headStrList.add("Group");
		headStrList.add("Sub-group");
		headStrList.add("Description");
		headStrList.add("log(E value)");
		headStrList.add("Coverage");
		headStrList.add("MW");
		headStrList.add("Spectra");
		headStrList.add("Specific uniques");
		headStrList.add("Uniques");
		headStrList.add("PAI");
		headStrList.add("Redundancy");

		for (String title : headStrList) {
			odsTable.writeCell(title);
		}
	}

	public void print_group_information(Group group) throws Exception {
		logger.debug("printing group " + group.getNumber());
		for (SubGroup sg : group.getSubGroupSet().getSubGroupList()) {
			logger.debug("printing subgroup " + sg.getNumber());
			for (HashSampleScanSetProt hashProt : sg
					.getHashSampleScanSetProtList()) {
				odsTable.writeLine();
				// StringBuilder S = new StringBuilder();
				Match top = hashProt.getMatch();

				odsTable.writeCell("" + group.getNumber());
				// S.append(group.getNumber() + "\t"
				odsTable.writeCell(""
						+ this.get_subgroup_number(group, sg));
				// + this.get_subgroup_number(group, sg) + "\t"
				odsTable.writeCell(""
						+ top.get_protein_match().get_description());
				// + top.get_protein_match().get_description());
				odsTable.writeCell(new Double(top.get_protein_match()
						.get_evalue()));
				// S.append("\t" + top.get_protein_match().get_evalue());
				odsTable.writeCell(new Double(top.get_coverage()));
				// S.append("\t" + top.get_coverage());
				odsTable.writeCell(new Double(top.get_protein_match()
						.get_mw()));
				// S.append("\t" + top.get_protein_match().get_mw());
				odsTable.writeCell(new Double(top
						.get_valid_peptide_number()));
				// S.append("\t" + top.get_valid_peptide_number());
				if (group.getSubGroupSet().size() > 1) {
					odsTable.writeCell(new Double(
							group.getNumberOfSpecificUniquePeptideInSubGroup(hashProt)));
					// S.append("\t"
					// +
					// group.getNumberOfSpecificUniquePeptideInSubGroup(hashProt));
				} else {
					odsTable.writeCell("-");
				}
				odsTable.writeCell(new Double(top
						.get_unique_valid_peptide_number()));
				// S.append("\t" + top.get_unique_valid_peptide_number());
				odsTable.writeCell(new Double((float) top
						.get_valid_peptide_number()
						/ top.get_protein_match().get_PAI_count()));
				// S.append("\t");
				// S.append((float) top.get_valid_peptide_number()
				// / top.get_protein_match().get_PAI_count() + "\t");
				if (sg.getHashSampleScanSetProtSet().size() > 1) {
					odsTable.writeCell("* "
							+ sg.getHashSampleScanSetProtSet().size());
					// S.append("* " + sg.getHashSampleScanSetProtSet().size());
				}
				// S.append("\n");

				// out.write(S.toString());
			}
		}
		odsTable.writeLine();
		// out.write("\n");
	}
}
